﻿Public Class frmDatenaustausch

    Dim strDateiname As String
    
    Private Sub butStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butStart.Click
        Dim strDatei As String
        With OpenFileDialog1
            .InitialDirectory = "C:\Users\User\Documents\Visio\Visio2010\CD\Kapitel03\"
            .Filter = "Visio-Zeichnungen (*.vsd)|*.vsd|Alle Visio-Dateien (*.vsd, *.vst, " & _
             "*.vss)|*.vs?|Alle Dateien (*.*)|*.*"
            .FilterIndex = 1
            .FileName = ""

            .Multiselect = False
            .InitialDirectory = System.IO.Directory.GetCurrentDirectory()
            .Title = "Bitte wählen Sie eine Datei aus!"
            If .ShowDialog() = Windows.Forms.DialogResult.OK Then
                Me.lblInfo.Visible = True

                strDatei = .FileName
                VisioInfosLesen(strDatei)
                Me.Close()
            End If
        End With

    End Sub

    Private Sub butAbbrechen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butAbbrechen.Click
        Me.Close()
    End Sub

    Private Sub VisioInfosLesen(ByVal Dateiname As String)
        Dim vsApp As Microsoft.Office.Interop.Visio.Application
        Dim vsDatei As Microsoft.Office.Interop.Visio.Document
        Dim vsBlatt As Microsoft.Office.Interop.Visio.Page
        Dim vsShape As Microsoft.Office.Interop.Visio.Shape
        Dim xmlDoc As System.Xml.XmlDocument
        Dim xmlPI As System.Xml.XmlProcessingInstruction
        Dim xmlWurzel As System.Xml.XmlElement
        Dim xmlShape As System.Xml.XmlElement
        Dim xmlKnoten As System.Xml.XmlElement
        Dim xmlTrans As System.Xml.Xsl.XslCompiledTransform
        Dim i As Integer
        Dim blnBenEig As Boolean
        Dim strPfad As String


        Try
            If System.IO.File.Exists(Dateiname) = False Then
                MessageBox.Show("Der Dateiname ist falsch" & _
                    System.Environment.NewLine & _
                    "Oder der Pfad ungültig.")
                Exit Sub
            End If

            strPfad = Dateiname.Substring(0, Dateiname.LastIndexOf("\"))
            strDateiname = Dateiname.Substring(Dateiname.LastIndexOf("\") + 1)
            ProgressLäuft()

            xmlDoc = New System.Xml.XmlDocument : ProgressLäuft()
            xmlPI = xmlDoc.CreateProcessingInstruction("xml", "version='1.0' encoding='UTF-8'")
            xmlDoc.AppendChild(xmlPI)
            xmlWurzel = xmlDoc.CreateElement("Liste")
            xmlDoc.AppendChild(xmlWurzel)
            ProgressLäuft()

            vsApp = New Microsoft.Office.Interop.Visio.Application
            ProgressLäuft()
            vsApp.Visible = False
            ProgressLäuft()
            vsDatei = vsApp.Documents.Open(Dateiname)
            ProgressLäuft()
            blnBenEig = False
            For Each vsBlatt In vsDatei.Pages
                For Each vsShape In vsBlatt.Shapes
                    xmlShape = xmlDoc.CreateElement("Shape")
                    xmlWurzel.AppendChild(xmlShape)
                    ProgressLäuft()
                    If vsShape.SectionExists(243, 0) = True Then
                        For i = 0 To vsShape.RowCount(243) - 1
                            xmlKnoten = xmlDoc.CreateElement("Daten" & i)
                            xmlShape.AppendChild(xmlKnoten)
                            xmlKnoten.InnerText = _
                            (vsShape.Section _
                            (243).Row(i).Cell(2).Formula & _
                             ": " & vsShape.Section(243). _
                             Row(i).Cell(0).Formula).Replace("""", "")
                            blnBenEig = True
                            ProgressLäuft()
                        Next
                    End If
                Next
            Next
            If blnBenEig = False Then
                MessageBox.Show("Es wurden keine " & _
                "benutzerdefinierten Eigenschaften gefunden.")
            End If
            xmlDoc.Save(strPfad & "\VisioExport.xml")
            vsDatei.Close()
            vsApp.Quit()
            TranformationsdateiErstellen(strPfad)

            xmlTrans = New System.Xml.Xsl.XslCompiledTransform
            xmlTrans.Load(strPfad & "\VisioTransform2.xsl")
            xmlTrans.Transform(strPfad & "\VisioExport.xml", strPfad & "\ausgabe.html")

            MessageBox.Show("Der Datenexport verlief erfolgreich.")

        Catch ex As Exception
            MessageBox.Show("es trat ein Fehler auf:" & _
            vbCr & ex.Message)
        Finally


            vsShape = Nothing
            vsBlatt = Nothing
            vsDatei = Nothing
            vsApp = Nothing

        End Try
    End Sub

    Sub TranformationsdateiErstellen(ByVal Pfad As String)
        Dim xmlDoc As System.Xml.XmlDocument
        Dim xmlPI As System.Xml.XmlProcessingInstruction
        Dim xmlNS As System.Xml.XmlNamespaceManager
        Dim xmlAtt As System.Xml.XmlAttribute
        Dim xmlWurzel As System.Xml.XmlElement
        Dim xmlE1 As System.Xml.XmlElement
        Dim xmlE2 As System.Xml.XmlElement
        Dim xmlE3 As System.Xml.XmlElement
        Dim xmlE4 As System.Xml.XmlElement
        Dim xmlE5 As System.Xml.XmlElement
        Dim xmlE6 As System.Xml.XmlElement
        Dim xmlE7 As System.Xml.XmlElement
        Dim xmlE8 As System.Xml.XmlElement
        Dim xmlE9 As System.Xml.XmlElement
        Dim i As Integer

        ProgressLäuft()
        xmlDoc = New System.Xml.XmlDocument
        xmlPI = xmlDoc.CreateProcessingInstruction("xml", "version='1.0' encoding='UTF-8'")
        xmlDoc.AppendChild(xmlPI)
        xmlWurzel = xmlDoc.CreateElement("xsl", "stylesheet", "xsl")
        xmlDoc.AppendChild(xmlWurzel)
        'xmlNS = New System.Xml.XmlNamespaceManager(xmlDoc.NameTable)
        'xmlNS.AddNamespace("xsl", "http://www.w3.org/1999/XSL/Transform")
        xmlAtt = xmlDoc.CreateAttribute("version")
        xmlWurzel.Attributes.Append(xmlAtt)
        xmlAtt.InnerText = "2.0"
        xmlAtt = xmlDoc.CreateAttribute("xmlns:xsl")
        xmlWurzel.Attributes.Append(xmlAtt)
        xmlAtt.InnerText = "http://www.w3.org/1999/XSL/Transform"
        xmlAtt = xmlDoc.CreateAttribute("xmlns:fo")
        xmlWurzel.Attributes.Append(xmlAtt)
        xmlAtt.InnerText = "http://www.w3.org/1999/XSL/Format"
        xmlAtt = xmlDoc.CreateAttribute("xmlns:xs")
        xmlWurzel.Attributes.Append(xmlAtt)
        xmlAtt.InnerText = "http://www.w3.org/2001/XMLSchema"
        xmlAtt = xmlDoc.CreateAttribute("xmlns:fn")
        xmlWurzel.Attributes.Append(xmlAtt)
        xmlAtt.InnerText = "http://www.w3.org/2005/xpath-functions"



        xmlE1 = xmlDoc.CreateElement("xsl:output", "http://www.w3.org/1999/XSL/Transform")
        xmlAtt = xmlDoc.CreateAttribute("method")
        xmlE1.Attributes.Append(xmlAtt)
        xmlAtt.InnerText = "html"
        xmlAtt = xmlDoc.CreateAttribute("indent")
        xmlE1.Attributes.Append(xmlAtt)
        xmlAtt.InnerText = "yes"
        xmlWurzel.AppendChild(xmlE1)  '<xsl:output method="html" indent="yes"/>

        xmlE1 = xmlDoc.CreateElement("xsl:template", "http://www.w3.org/1999/XSL/Transform")
        xmlAtt = xmlDoc.CreateAttribute("match")
        xmlE1.Attributes.Append(xmlAtt)
        xmlAtt.InnerText = "/"
        xmlWurzel.AppendChild(xmlE1)  ' <xsl:template match="/">

        xmlE2 = xmlDoc.CreateElement("html")
        xmlE1.AppendChild(xmlE2)    '<html>

        xmlE3 = xmlDoc.CreateElement("head")
        xmlE2.AppendChild(xmlE3)   '<head>

        xmlE4 = xmlDoc.CreateElement("title")
        xmlE3.AppendChild(xmlE4)
        xmlE4.InnerText = "Die Daten der Datei: " & strDateiname  '<title>

        xmlE3 = xmlDoc.CreateElement("body")
        xmlE2.AppendChild(xmlE3)   '<body>


        xmlE4 = xmlDoc.CreateElement("style")
        xmlE3.AppendChild(xmlE4)
        xmlE4.InnerText = ".Tabellenkopf {text-align:center;color:red;font-family:Arial;font-size:24pt;font-weight:bold; } " & _
           ".Tabelle { color:blue;font-family:Times;font-size:12pt; }"

        xmlE4 = xmlDoc.CreateElement("h1")
        xmlE3.AppendChild(xmlE4)
        xmlE4.InnerText = "Ausgewertete Visio-Datei: " & strDateiname

        xmlE4 = xmlDoc.CreateElement("table")
        xmlAtt = xmlDoc.CreateAttribute("border")
        xmlE4.Attributes.Append(xmlAtt)
        xmlAtt.InnerText = "1"
        xmlAtt = xmlDoc.CreateAttribute("width")
        xmlE4.Attributes.Append(xmlAtt)
        xmlAtt.InnerText = "100%"
        xmlE3.AppendChild(xmlE4)  '<table border="1" width="100%">

        xmlE5 = xmlDoc.CreateElement("tbody")
        xmlE4.AppendChild(xmlE5)  '<tbody>

        xmlE6 = xmlDoc.CreateElement("tr")
        xmlE5.AppendChild(xmlE6)
        xmlAtt = xmlDoc.CreateAttribute("class")
        xmlE6.Attributes.Append(xmlAtt)
        xmlAtt.InnerText = "Tabellenkopf"  '<tr>

        For i = 1 To 5
            xmlE7 = xmlDoc.CreateElement("th")
            xmlE6.AppendChild(xmlE7)
            xmlE7.InnerText = "Daten0" & i.ToString
        Next

        xmlE6 = xmlDoc.CreateElement("xsl:for-each", "http://www.w3.org/1999/XSL/Transform")
        xmlE5.AppendChild(xmlE6)
        xmlAtt = xmlDoc.CreateAttribute("select")
        xmlE6.Attributes.Append(xmlAtt)
        xmlAtt.InnerText = "Liste/Shape"  '<xsl:for-each select="Liste/Shape">

        xmlE7 = xmlDoc.CreateElement("tr")
        xmlE6.AppendChild(xmlE7)
        xmlAtt = xmlDoc.CreateAttribute("class")
        xmlE7.Attributes.Append(xmlAtt)
        xmlAtt.InnerText = "Tabelle"  '<tr class="Tabelle">

        For i = 0 To 4
            xmlE8 = xmlDoc.CreateElement("td")
            xmlE7.AppendChild(xmlE8)  '<td>

            xmlE9 = xmlDoc.CreateElement("xsl:value-of", "http://www.w3.org/1999/XSL/Transform")
            xmlE8.AppendChild(xmlE9)
            xmlAtt = xmlDoc.CreateAttribute("select")
            xmlE9.Attributes.Append(xmlAtt)
            xmlAtt.InnerText = "Daten" & i.ToString  '<xsl:for-each select="Liste/Shape">
        Next i


        ProgressLäuft()
        xmlDoc.Save(Pfad & "\VisioTransform2.xsl")
        ProgressLäuft()
    End Sub

    Sub ProgressLäuft()
        If Me.ProgressBar1.Value < 100 Then
            Me.ProgressBar1.Value = Me.ProgressBar1.Value + 1
        End If

    End Sub


End Class
